#define NULE 0
#define FULE 255
#define RULE 1

typedef struct NOiD_empty
{

	void * start;
	void * end;
	struct NOiD_empty * last;
	struct NOiD_empty * next;
	int size;
} NOiD_empty;

typedef struct NOiD_seg
{
	void * start;
	void * end;
	NOiD_empty * empty;
	int size;
} NOiD_seg;
//=======================================================================================
//=======================================================================================
//=======================================================================================
//=======================================================================================
NOiD_seg * NOiD_setseg (void * noid_offset, int noid_size)
{
	//newf proof
	if ((noid_size == NULE)||(noid_offset == NULE))
	{	return NULE;	}
	//temporary variable structure
	NOiD_seg * noid_new_seg = (NOiD_seg*) noid_offset;
	NOiD_empty * noid_new_empty = (NOiD_empty*)(noid_offset+sizeof(NOiD_seg));
	//prepare the segment basic info
	noid_new_seg->start = noid_offset;
	noid_new_seg->end = noid_offset + noid_size;
	noid_new_seg->size = noid_size;
	noid_new_seg->empty = noid_new_empty;
	//prepare the empty space basic info
	noid_new_empty->start = noid_offset + noid_size;
	noid_new_empty->end = noid_offset + noid_size;
	noid_new_empty->last = noid_new_empty;
	noid_new_empty->next = (NOiD_empty*)(noid_offset+sizeof(NOiD_seg)+sizeof(NOiD_empty));
	noid_new_empty->size = 0;
	noid_new_empty->next->start = noid_offset + sizeof(NOiD_seg) + sizeof(NOiD_empty)*2;
	noid_new_empty->next->end = noid_offset + noid_size - 1;
	noid_new_empty->next->last = noid_new_empty;
	noid_new_empty->next->next = noid_new_empty;
	noid_new_empty->next->size = (int)noid_new_empty->next->end - (int)noid_new_empty->next->start;

	return noid_new_seg;
}
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
void * NOiD_alloc (NOiD_seg * noid_segment, int noid_size)
{
	//newf proof
	if ((noid_size < sizeof(NOiD_empty))||(noid_segment == NULE)||(noid_segment->size < noid_size))
	{	return NULE;	}
	//temporary variable
	void * noid_new_offset = NULE;
	NOiD_empty * noid_best_empty;
	//check if an empty space meet the requirement
	noid_best_empty = noid_segment->empty;
	int noid_got_empty = 0;
	while (noid_got_empty == 0)
	{
		if (noid_best_empty->size < noid_size)
		{
			if (noid_best_empty->next != noid_best_empty->next->last)
			{
				noid_best_empty = noid_best_empty->next;
			} 
			else
			{
				noid_best_empty = NULE;
				noid_got_empty = 1;
			}
		} 
		else
		{
			noid_got_empty = 1;
		}
	}
	//then if we got an empty space aligned with enough bytes
	if (noid_best_empty != NULE)
	{
	noid_new_offset =noid_best_empty->start;
	noid_best_empty->start += sizeof(int) + noid_size;
	noid_best_empty->size = (int)noid_best_empty->end - (int)noid_best_empty->start;
	*(int*)noid_new_offset = noid_size;
	noid_new_offset += sizeof(int); 
/*				//debug debug debug debug debug bedug
				int * noid_pivot = noid_new_offset;
				while (noid_pivot <= (int*)(noid_new_offset + noid_size - sizeof(int)))
				{
					*noid_pivot = RULE;
					noid_pivot += 1;
				}
*/				//debug debug debug debug debug bedug
	}
	return noid_new_offset;
}
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
void NOiD_free (NOiD_seg * noid_segment, void * noid_offset)
{
	//newf proof
	if ((noid_segment == NULE)||(noid_offset == NULE))
	{	return;	}
	//temporary variable
	void * noid_real_offset = noid_offset - sizeof(int);
	int noid_size = *(int*)(noid_offset-sizeof(int));
	NOiD_empty * noid_now_empty;
	//try to find an empty space thats aligned with noid_offset
	noid_now_empty = noid_segment->empty;
	while (noid_now_empty->next != noid_now_empty->next->last)
	{
		if (noid_now_empty->start == (noid_offset + noid_size))
		{
			noid_now_empty->start = noid_real_offset;
			noid_now_empty->size = (int)noid_now_empty->end - (int)noid_now_empty->start;
			return;
		}
		if (noid_now_empty->end == noid_real_offset)
		{
			noid_now_empty->end = noid_offset + noid_size;
			noid_now_empty->size = (int)noid_now_empty->end - (int)noid_now_empty->start;
			return;
		}
		noid_now_empty = noid_now_empty->next;
	}
	//there is no empty space aligned fith noid_offset!!! that is sad !!!
	//create a new empty entry to declare that the space will be free
	//build the empty space using the allocated space we use
	noid_now_empty = (NOiD_empty*)noid_real_offset;
	noid_now_empty->start = noid_real_offset + sizeof(NOiD_empty);
	noid_now_empty->end = noid_offset + noid_size;
	noid_now_empty->last = noid_segment->empty;
	noid_now_empty->next = noid_segment->empty->next;
	noid_now_empty->size = (int)noid_now_empty->end - (int)noid_now_empty->start;
	noid_segment->empty->next = noid_now_empty;
	noid_now_empty->next->last = noid_now_empty;
}
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
void NOiD_defrag (NOiD_seg * noid_segment)
{
	//temporary variable
	NOiD_empty * noid_tester, * noid_tested;
	//loop loop
	noid_tester = noid_segment->empty;
	while (noid_tester->next != noid_tester->next->last)
	{
		noid_tested = noid_tester;
		while (noid_tested->next != noid_tested->next->last)
		{
			if (noid_tested != noid_tester)
			{
				if (noid_tested->start == (void*)noid_tested + sizeof(NOiD_empty))
				{
					if (noid_tester->end == (void*)noid_tested)
					{
						noid_tester->end = noid_tested->end;
						noid_tested->last->next = noid_tested->next;
						noid_tested->next->last = noid_tested->last;
						noid_tester->size = (int)noid_tester->end - (int)noid_tester->start;	
					}
					if (noid_tester->start == noid_tested->end)
					{
						noid_tester->start = (void*)noid_tested;
						noid_tested->last->next = noid_tested->next;
						noid_tested->next->last = noid_tested->last;
						noid_tester->size = (int)noid_tester->end - (int)noid_tester->start;	
					}
				}
			}
			noid_tested = noid_tested->next;
		}
					//debug debug debug debug debug bedug debug debug debug debug debug
					int * noid_pivot = noid_tester->start;			//bug debug
					while (noid_pivot <= (int*)noid_tester->end - 1)	//bug debug
					{							//bug debug
						*noid_pivot = NULE;				//bug debug
						noid_pivot += 1;				//bug debug
					}							//bug debug
					//debug debug debug debug debug bedug debug debug debug debug debug
		noid_tester = noid_tester->next;
	}
}
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
